﻿using System;
using System.Runtime.InteropServices;
using static XFUDriver.XFUDriver;

namespace Drive_CSP_500us_CSharp
{
    partial class Program
    {
        private static object _threadLock = new object();
        static RxPDO cmdData;
        static TxPDO respData;
        [StructLayout(LayoutKind.Sequential, Pack = 1)]
        public struct RxPDODriver //Struct define for rxPDODriver
        {
            public UInt16 CtlWord;
            public int Target;
        }
        [StructLayout(LayoutKind.Sequential, Pack = 1)]
        public struct TxPDODriver //Struct define for txPDO
        {
            public UInt16 StaWord;
            public int Current;
        }
        [StructLayout(LayoutKind.Sequential, Pack = 1)]
        public struct RxPDO //Struct define for rxPDO
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = TEST_PDO_TO_FIFO_ONCE)]
            public  RxPDODriver[] Driver;
        }
        [StructLayout(LayoutKind.Sequential, Pack = 1)]
        public struct TxPDO //Struct define for txPDO
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = TEST_PDO_TO_FIFO_ONCE)]
            public TxPDODriver[] Driver;
        }
        public static void toBytes()
        {
            lock (_threadLock)
            {
                IntPtr ptr = Marshal.AllocHGlobal(PKG_DATA_DEFAULT_SIZE);
                int size = Marshal.SizeOf(cmdData.GetType());
                Marshal.StructureToPtr(cmdData, ptr, true);
                Marshal.Copy(ptr, g_u8RxPDO, 0, size);
                Marshal.FreeHGlobal(ptr);
            }
        }

        private static void fromBytes()
        {
            int size = Marshal.SizeOf(respData.GetType());
            IntPtr ptr = Marshal.AllocHGlobal(size);
            Type respType = respData.GetType();
            try
            {
                lock (_threadLock)
                {
                    Marshal.Copy(g_u8TxPDO, 0, ptr, size);
                    respData = (TxPDO)Marshal.PtrToStructure(ptr, respType);
                }
            }
            catch (Exception)
            {
                //throw new Exception("緩衝區不夠");
            }
            finally
            {
                Marshal.FreeHGlobal(ptr);
            }
        }
    }
}
