﻿using System;
using System.Runtime.InteropServices;
using static XFUDriver.XFUDriver;

namespace Drive_Homing_PP_CSharp
{
    partial class Program
    {
        private static object _threadLock = new object();
        static RxPDO cmdData;
        static TxPDO respData;
        [StructLayout(LayoutKind.Sequential, Pack = 1)]
        public struct RxPDO //Struct define for rxPDO
        {
            public UInt16 CtlWord1;
            public int Target1;
        }
        [StructLayout(LayoutKind.Sequential, Pack = 1)]
        public struct TxPDO //Struct define for txPDO
        {
            public UInt16 StaWord1;
            public int Current1;
        }
        public static void toBytes()
        {
            lock (_threadLock)
            {
                IntPtr ptr = Marshal.AllocHGlobal(PKG_DATA_DEFAULT_SIZE);
                int size = Marshal.SizeOf(cmdData.GetType());
                Marshal.StructureToPtr(cmdData, ptr, true);
                Marshal.Copy(ptr, g_u8RxPDO, 0, size);
                Marshal.FreeHGlobal(ptr);
            }
        }

        private static void fromBytes()
        {
            int size = Marshal.SizeOf(respData.GetType());
            IntPtr ptr = Marshal.AllocHGlobal(size);
            Type respType = respData.GetType();
            try
            {
                lock (_threadLock)
                {
                    Marshal.Copy(g_u8TxPDO, 0, ptr, size);
                    respData = (TxPDO)Marshal.PtrToStructure(ptr, respType);
                }
            }
            catch (Exception)
            {
                //throw new Exception("緩衝區不夠");
            }
            finally
            {
                Marshal.FreeHGlobal(ptr);
            }
        }
    }
}
