/******************************************************************************
 *	File	:	PdoDefine.h
 *	Version :	0.2
 *	Date	:	2020/09/03
 *	Author	:	XFORCE
 *
 *
 *	Define slave device PDO data structure
 *
 *	You can configure the PDO structure you wanted,
 *	or you can just use the default PDO structure.
 *	No matter what, the example program need to know.
 *
 * @copyright (C) 2020 NEXTW TECHNOLOGY CO., LTD.. All rights reserved.
 *
 ******************************************************************************/
#include <stdio.h>
#include <EcmDriver.h>

#ifndef _ECM_USR_PDO_DEFINE_H_
#define _ECM_USR_PDO_DEFINE_H_

#define TEST_SLAVE_CNT			1

#define RxPDO_ASSIGN_IDX		0x1C12
#define TxPDO_ASSIGN_IDX		0x1C13

#define RxPDO_MAP_IDX			0x1600
#define TxPDO_MAP_IDX			0x1A00

#define RXPDO_SIZE_BYTES		6
#define TXPDO_SIZE_BYTES		6

#define IO_RXPDO_SIZE_BYTE		2
#define IO_TXPDO_SIZE_BYTE		2

#define TEST_PDO_TO_FIFO_ONCE  2

ECM_PACK_BEGIN
typedef struct ECM_PACK driver_rxpdo_st_def_t
{
	uint16_t u16CtlWord;
	int32_t n32TarPos;
}DRIVER_RXPDO_ST_DEF_T;
ECM_PACK_END

ECM_PACK_BEGIN
typedef struct ECM_PACK driver_txpdo_st_def_t
{
	uint16_t u16StaWord;
	int32_t n32AcuPos;
}DRIVER_TXPDO_ST_DEF_T;
ECM_PACK_END

ECM_PACK_BEGIN
typedef struct ECM_PACK IO_rxpdo_st_def_t
{
	uint16_t u16RxData;
}IO_RXPDO_ST_DEF_T;
ECM_PACK_END

ECM_PACK_BEGIN
typedef struct ECM_PACK IO_txpdo_st_def_t
{
	uint16_t u16TxData;
}IO_TXPDO_ST_DEF_T;
ECM_PACK_END

ECM_PACK_BEGIN
typedef struct ECM_PACK rxpdo_st_def_t
{
	DRIVER_RXPDO_ST_DEF_T DRIVE_GROUP_0[1];
}RXPDO_ST_DEF_T;
ECM_PACK_END

ECM_PACK_BEGIN
typedef struct ECM_PACK txpdo_st_def_t
{
	DRIVER_TXPDO_ST_DEF_T DRIVE_GROUP_0[1];
}TXPDO_ST_DEF_T;
ECM_PACK_END

ECM_PACK_BEGIN
typedef struct ECM_PACK Total_rxpdo_st_def_t
{
	RXPDO_ST_DEF_T CycleCmd[TEST_PDO_TO_FIFO_ONCE];
}TOTAL_RXPDO_ST_DEF_T;
ECM_PACK_END

ECM_PACK_BEGIN
typedef struct ECM_PACK Total_txpdo_st_def_t
{
	TXPDO_ST_DEF_T CycleResp[TEST_PDO_TO_FIFO_ONCE];
}TOTAL_TXPDO_ST_DEF_T;
ECM_PACK_END
#endif
